<?php
/* vim: set fileencoding=cp932 ai et ts=4 sw=4 sts=0 fdm=marker: */
/* mi: charset=Shift_JIS */

require_once P2_LIB_DIR . '/dataphp.class.php';
require_once P2_LIB_DIR . '/filectl.class.php';

/**
 * p2 - p2p̃[eBeBNX
 * CX^X炸ɃX^eBbN\bhŗp
 * 
 * @created  2004/07/15
 */
class P2Util
{
    /**
     * t@C_E[hۑ
     *
     * @access  public
     * @return  WapResponse|false
     */
    function fileDownload($url, $localfile, $disp_error = true, $use_tmp_file = false)
    {
        global $_conf;
        
        $me = __CLASS__ . '::' . __FUNCTION__ . '()';
        
        if (strlen($localfile) == 0) {
            trigger_error("$me, localfile is null", E_USER_WARNING);
            return false;
        }
        
        $perm = isset($_conf['dl_perm']) ? $_conf['dl_perm'] : 0606;
    
        if (file_exists($localfile)) {
            $modified = gmdate("D, d M Y H:i:s", filemtime($localfile)) . " GMT";
        } else {
            $modified = false;
        }
    
        // DL
        require_once P2_LIB_DIR . '/wap.class.php';
        $wap_ua =& new WapUserAgent;
        $wap_ua->setTimeout($_conf['fsockopen_time_limit']);
        
        $wap_req =& new WapRequest;
        $wap_req->setUrl($url);
        $wap_req->setModified($modified);
        if ($_conf['proxy_use']) {
            $wap_req->setProxy($_conf['proxy_host'], $_conf['proxy_port']);
        }
        
        $wap_res = $wap_ua->request($wap_req);
        
        if (!$wap_res or !$wap_res->is_success() && $disp_error) {
            $url_t = P2Util::throughIme($wap_req->url);
            P2Util::pushInfoHtml("<div>Error: {$wap_res->code} {$wap_res->message}<br>"
                                . "p2 info: <a href=\"{$url_t}\"{$_conf['ext_win_target_at']}>{$wap_req->url}</a> ɐڑł܂łB</div>");
        }
        
        // XVĂ
        if ($wap_res->is_success() && $wap_res->code != "304") {
        
            if ($use_tmp_file) {
                if (!is_dir($_conf['tmp_dir'])) {
                    if (!FileCtl::mkdirR($_conf['tmp_dir'])) {
                        die("Error: $me, cannot mkdir.");
                        return false;
                    }
                }
                if (FileCtl::filePutRename($localfile, $wap_res->content) === false) {
                    trigger_error("$me, FileCtl::filePutRename() return false. " . $localfile, E_USER_WARNING);
                    die("Error:  $me, cannot write file.");
                    return false;
                }
            } else {
                if (file_put_contents($localfile, $wap_res->content, LOCK_EX) === false) {
                    die("Error:  $me, cannot write file.");
                    return false;
                }
            }
            chmod($localfile, $perm);
        }

        return $wap_res;
    }

    /**
     * fBNgɏ݌ȂΒӂ\Zbg
     *
     * @access  public
     * @return  void
     */
    function checkDirWritable($aDir)
    {
        global $_conf;
        
        $msg_ht = '';
        
        // }`[U[h́A񃁃bZ[W}ĂB
        
        if (!is_dir($aDir)) {
            /*
            $msg_ht .= '<p class="infomsg">';
            $msg_ht .= ': f[^ۑpfBNg܂B<br>';
            $msg_ht .= $aDir."<br>";
            */
            if (is_dir(dirname(realpath($aDir))) && is_writable(dirname(realpath($aDir)))) {
                //$msg_ht .= "fBNg̎쐬݂܂...<br>";
                if (mkdir($aDir, $_conf['data_dir_perm'])) {
                    //$msg_ht .= "fBNg̎쐬܂B";
                    chmod($aDir, $_conf['data_dir_perm']);
                } else {
                    //$msg_ht .= "fBNg쐬ł܂łB<br>蓮ŃfBNg쐬Ap[~bVݒ肵ĉB";
                }
            } else {
                    //$msg_ht .= "fBNg쐬Ap[~bVݒ肵ĉB";
            }
            //$msg_ht .= '</p>';
            
        } elseif (!is_writable($aDir)) {
            $msg_ht .= '<p class="infomsg">: f[^ۑpfBNgɏ݌܂B<br>';
            //$msg_ht .= $aDir.'<br>';
            $msg_ht .= 'fBNg̃p[~bVĉB</p>';
        }
        
        $msg_ht and P2Util::pushInfoHtml($msg_ht);
    }

    /**
     * _E[hURLLbVt@CpXԂ
     *
     * @access  public
     * @return  string|false
     */
    function cacheFileForDL($url)
    {
        global $_conf;

        if (!$parsed = parse_url($url)) {
            return false;
        }

        $save_uri = $parsed['host'];
        $save_uri .= isset($parsed['port']) ? ':'. $parsed['port'] : ''; 
        $save_uri .= $parsed['path'] ? $parsed['path'] : ''; 
        $save_uri .= isset($parsed['query']) ? '?'. $parsed['query'] : '';
        
        $save_uri = str_replace('%2F', '/', rawurlencode($save_uri));
        $save_uri = preg_replace('|\.+/|', '', $save_uri);
        
        $cachefile = $_conf['cache_dir'] . "/" . $save_uri;
        
        FileCtl::mkdirFor($cachefile);
        
        return $cachefile;
    }

    /**
     * hostbbs擾
     *
     * @access  public
     * @return  string|null
     */
    function getItaName($host, $bbs)
    {
        global $_conf, $ita_names;
        
        $id = $host . '/' . $bbs;
        
        if (isset($ita_names[$id])) {
            return $ita_names[$id];
        }

        $idx_host_dir = P2Util::idxDirOfHost($host);
        $p2_setting_txt = $idx_host_dir . "/" . $bbs . "/p2_setting.txt";
        
        if (file_exists($p2_setting_txt)) {

            $p2_setting_cont = file_get_contents($p2_setting_txt);

            if ($p2_setting_cont) {
                $p2_setting = unserialize($p2_setting_cont);
                if (isset($p2_setting['itaj'])) {
                    $ita_names[$id] = $p2_setting['itaj'];
                    return $ita_names[$id];
                }
            }
        }

        // Long̎擾
        if (!isset($p2_setting['itaj'])) {
            require_once P2_LIB_DIR . '/BbsMap.class.php';
            $itaj = BbsMap::getBbsName($host, $bbs);
            if ($itaj != $bbs) {
                $ita_names[$id] = $p2_setting['itaj'] = $itaj;
                
                FileCtl::make_datafile($p2_setting_txt, $_conf['p2_perm']);
                $p2_setting_cont = serialize($p2_setting);
                if (FileCtl::filePutRename($p2_setting_txt, $p2_setting_cont) === false) {
                    die("Error: {$p2_setting_txt} XVł܂ł");
                }
                return $ita_names[$id];
            }
        }
        
        return null;
    }

    /**
     * hostdat̕ۑfBNgԂ
     *
     * @access  public
     * @return  string
     */
    function datDirOfHost($host)
    {
        global $_conf;

        // 2channel or bbspink
        if (P2Util::isHost2chs($host)) {
            $dat_host_dir = $_conf['dat_dir'] . "/2channel";
        // machibbs.com
        } elseif (P2Util::isHostMachiBbs($host)) {
            $dat_host_dir = $_conf['dat_dir'] . "/machibbs.com";
        } else {
            $host_path = $host;
            // {rawurlencodeA݊cߍTĂ
            //$host_path = str_replace('%2F', '/', rawurlencode($host_path));
            $host_path = preg_replace('|\.+/|', '', $host_path);
            $host_path = preg_replace('|:+//|', '', $host_path); // mkdir()://JgfBNgłƂ݂ȂH
            $dat_host_dir = $_conf['dat_dir'] . "/" . $host_path;
        }
        return $dat_host_dir;
    }
    
    /**
     * hostidx̕ۑfBNgԂ
     *
     * @access  public
     * @return  string
     */
    function idxDirOfHost($host)
    {
        global $_conf;

        // 2channel or bbspink
        if (P2Util::isHost2chs($host)) { 
            $idx_host_dir = $_conf['idx_dir'] . "/2channel";
        // machibbs.com
        } elseif (P2Util::isHostMachiBbs($host)){ 
            $idx_host_dir = $_conf['idx_dir'] . "/machibbs.com";
        } else {
            $host_path = $host;
            //$host_path = str_replace('%2F', '/', rawurlencode($host_path));
            $host_path = preg_replace('|\.+/|', '', $host_path);
            $host_path = preg_replace('|:+//|', '', $host_path);
            $idx_host_dir = $_conf['idx_dir'] . "/" . $host_path;
        }
        return $idx_host_dir;
    }
    
    /**
     * failed_post_file ̃pX擾
     *
     * @access  public
     * @return  string
     */
    function getFailedPostFilePath($host, $bbs, $key = false)
    {
        // X
        if ($key) {
            $filename = $key . '.failed.data.php';
        // X
        } else {
            $filename = 'failed.data.php';
        }
        return $failed_post_file = P2Util::idxDirOfHost($host) . '/' . $bbs . '/' . $filename;
    }

    /**
     * Xg̃ir͈͂擾
     *
     * @access  public
     * @return  array
     */
    function getListNaviRange($disp_from, $disp_range, $disp_all_num)
    {
        $disp_end = 0;
        $disp_navi = array();
        $disp_navi['all_once'] = false;
        
        if (!$disp_all_num) {
            $disp_navi['from'] = 0;
            $disp_navi['end'] = 0;
            $disp_navi['all_once'] = true;
            $disp_navi['mae_from'] = 1;
            $disp_navi['tugi_from'] = 1;
            return $disp_navi;
        }    

        $disp_navi['from'] = $disp_from;
        
        $disp_range = $disp_range-1;
        
        // fromz
        if ($disp_navi['from'] > $disp_all_num) {
            $disp_navi['from'] = $disp_all_num - $disp_range;
            $disp_navi['from'] = max(1, $disp_navi['from']);
            $disp_navi['end'] = $disp_all_num;
        
        // from zȂ
        } else {
            // end z
            if ($disp_navi['from'] + $disp_range > $disp_all_num) {
                $disp_navi['end'] = $disp_all_num;
                if ($disp_navi['from'] == 1) {
                    $disp_navi['all_once'] = true;
                }
            // end zȂ
            } else {
                $disp_navi['end'] = $disp_from + $disp_range;
            }
        }
        
        $disp_navi['mae_from'] = $disp_from -1 -$disp_range;
        $disp_navi['mae_from'] = max(1, $disp_navi['mae_from']);
        $disp_navi['tugi_from'] = $disp_navi['end'] +1;


        if ($disp_navi['from'] == $disp_navi['end']) {
            $range_on_st = $disp_navi['from'];
        } else {
            $range_on_st = "{$disp_navi['from']}-{$disp_navi['end']}";
        }
        $disp_navi['range_st'] = "{$range_on_st}/{$disp_all_num} ";

        return $disp_navi;
    }

    /**
     * key.idx  data L^
     *
     * @access  public
     * @param   array   $data   vf̏ԂɈӖB
     */
    function recKeyIdx($keyidx, $data)
    {
        global $_conf;
        
        // {͔zŎ󂯎
        if (is_array($data)) {
            $cont = implode('<>', $data);
        // ݊pstringt
        } else {
            $cont = rtrim($data);
        }
        
        $cont = $cont . "\n";
        
        FileCtl::make_datafile($keyidx, $_conf['key_perm']);
        
        if (file_put_contents($keyidx, $cont, LOCK_EX) === false) {
            trigger_error("file_put_contents(" . $keyidx . ")", E_USER_WARNING);
            die("Error: cannot write file. recKeyIdx()");
            return false;
        }

        return true;
    }

    /**
     * pQ[gʂ߂URLϊs
     *
     * @access  public
     * @return  string
     */
    function throughIme($url)
    {
        global $_conf;
        
        // p2iméAenc, m, url ̈Œ肳Ă̂Œ
        
        if ($_conf['through_ime'] == "2ch") {
            $purl = parse_url($url);
            $url_r = $purl['scheme'] . "://ime.nu/" . $purl['host'] . $purl['path'];
        } elseif ($_conf['through_ime'] == "p2" || $_conf['through_ime'] == "p2pm") {
            $url_r = $_conf['p2ime_url'] . "?enc=1&amp;url=" . rawurlencode($url);
        } elseif ($_conf['through_ime'] == "p2m") {
            $url_r = $_conf['p2ime_url'] . "?enc=1&amp;m=1&amp;url=" . rawurlencode($url);
        } else {
            $url_r = $url;
        }
        return $url_r;
    }

    /**
     * host  AP[g http://find.2ch.net/enq/ Ȃ true Ԃ
     *
     * @access  public
     * @return  boolean
     */
    function isHostKossoriEnq($host)
    {
        if (preg_match('{^find\.2ch\.net/enq}', $host)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * host  2ch or bbspink Ȃ true Ԃ
     *
     * @access  public
     * @return  boolean
     */
    function isHost2chs($host)
    {
        // find.2ch.netiAP[gj͏
        if (preg_match("{^find\.2ch\.net}", $host)) {
            return false;
        }
        
        if (preg_match("/\.(2ch\.net|bbspink\.com)$/", $host)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * host  be.2ch.net Ȃ true Ԃ
     *
     * 2006/07/27 ͂Â\bhB
     * 2ch̔ړ]ɉāAbbs܂߂Ĕ肵ȂĂ͂ȂȂȂ̂ŁAisBbsBe2chNet()𗘗pB
     * Be̔ړ]ŁA2chɂEUC̔͂ȂȂ悤
     *
     * @access  public
     * @return  boolean
     * @see     isBbsBe2chNet()
     */
    function isHostBe2chNet($host)
    {
        if (preg_match("/^be\.2ch\.net$/", $host)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * bbsij  be.2ch Ȃ true Ԃ
     *
     * @since   2006/07/27
     * @access  public
     * @return  boolean
     */
    function isBbsBe2chNet($host, $bbs)
    {
        if (preg_match("/^be\.2ch\.net$/", $host)) {
            return true;
        }
        // [todo] bbsŔfĂ邪ASETTING.TXT  BBS_BE_ID=1 Ŕfق悢낤
        $be_bbs = array('be', 'nandemo', 'argue');
        if (P2Util::isHost2chs($host) && in_array($bbs, $be_bbs)) {
            return true;
        }
        return false;
    }
    
    /**
     * host  bbspink Ȃ true Ԃ
     *
     * @access  public
     * @return  boolean
     */
    function isHostBbsPink($host)
    {
        if (preg_match("/\.bbspink\.com$/", $host)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * host  machibbs Ȃ true Ԃ
     *
     * @access  public
     * @return  boolean
     */
    function isHostMachiBbs($host)
    {
        if (preg_match("/\.(machibbs\.com|machi\.to)$/", $host)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * host  machibbs.net ܂r˂ Ȃ true Ԃ
     *
     * @access  public
     * @return  booean
     */
    function isHostMachiBbsNet($host)
    {
        if (preg_match("/\.(machibbs\.net)$/", $host)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * host  JBBS@ Ȃ true Ԃ
     *
     * @access  public
     * @return  booean
     */
    function isHostJbbsShitaraba($host)
    {
        if (preg_match("/^(jbbs\.shitaraba\.com|jbbs\.livedoor\.com|jbbs\.livedoor\.jp)/", $host)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * JBBS@΂̃zXgύXɑΉĕϊ
     *
     * @access  public
     * @param   string    $str    zXgłURLłȂłǂ
     * @return  string
     */
    function adjustHostJbbs($str)
    {
        return preg_replace('/jbbs\.shitaraba\.com|jbbs\.livedoor\.com/', 'jbbs.livedoor.jp', $str, 1);
    }

    /**
     * http header no cache o͂
     *
     * @access  public
     * @return  void
     */
    function header_nocache()
    {
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // tߋ
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // ɏCĂ
        header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
        header("Cache-Control: post-check=0, pre-check=0", false);
        header("Pragma: no-cache"); // HTTP/1.0
    }

    /**
     * http header Content-Type o͂ip~\聨ini_set()Ɂj
     *
     * @access  public
     * @return  void
     */
    function header_content_type()
    {
        header("Content-Type: text/html; charset=Shift_JIS");
    }

    /**
     * f[^PHP`iTABj̏ݗdat`iTABjɕϊ
     *
     * ŏ́Adat`i<>ĵAf[^PHP`iTABjɂȂAĂ܂ v1.6.0 dat`i<>jɖ߂
     *
     * @access  public
     */
    function transResHistLogPhpToDat()
    {
        global $_conf;

        // ݗL^Ȃݒ̏ꍇ͉Ȃ
        if ($_conf['res_write_rec'] == 0) {
            return true;
        }

        if (is_readable($_conf['p2_res_hist_dat_php'])) {
            if ($cont = DataPhp::getDataPhpCont($_conf['p2_res_hist_dat_php'])) {
                // ^u؂肩<>؂ɕύX
                $cont = str_replace("\t", "<>", $cont);

                // p2_res_hist.dat ΁AOςăobNAbvBivȂj
                if (file_exists($_conf['p2_res_hist_dat'])) {
                    $bak_file = $_conf['p2_res_hist_dat'] . '.bak';
                    if (strstr(PHP_OS, 'WIN') and file_exists($bak_file)) {
                        unlink($bak_file);
                    }
                    rename($_conf['p2_res_hist_dat'], $bak_file);
                }
                
                // ۑ
                FileCtl::make_datafile($_conf['p2_res_hist_dat'], $_conf['res_write_perm']);
                if (file_put_contents($_conf['p2_res_hist_dat'], $cont, LOCK_EX) === false) {
                    trigger_error("file_put_contents(" . $_conf['p2_res_hist_dat'] . ")", E_USER_WARNING);
                }
                
                // p2_res_hist.dat.php 𖼑OςăobNAbvBivȂj
                $bak_file = $_conf['p2_res_hist_dat_php'] . '.bak';
                if (strstr(PHP_OS, 'WIN') and file_exists($bak_file)) {
                    unlink($bak_file);
                }
                rename($_conf['p2_res_hist_dat_php'], $bak_file);
            }
        }
        
        return true;
    }

    /**
     * dat`i<>j̏ݗf[^PHP`iTABjɕϊ
     *
     * @access  public
     * @return  boolean
     */
    function transResHistLogDatToPhp()
    {
        global $_conf;

        // ݗL^Ȃݒ̏ꍇ͉Ȃ
        if ($_conf['res_write_rec'] == 0) {
            return true;
        }

        // p2_res_hist.dat.php ȂāAp2_res_hist.dat ǂݍ݉\ł
        if ((!file_exists($_conf['p2_res_hist_dat_php'])) and is_readable($_conf['p2_res_hist_dat'])) {
            if ($cont = file_get_contents($_conf['p2_res_hist_dat'])) {
                // <>؂肩^u؂ɕύX
                // ܂^uSĊO
                $cont = str_replace("\t", "", $cont);
                // <>^uɕϊ
                $cont = str_replace("<>", "\t", $cont);
                
                // f[^PHP`ŕۑ
                if (!DataPhp::writeDataPhp($_conf['p2_res_hist_dat_php'], $cont, $_conf['res_write_perm'])) {
                    return false;
                }
            }
        }
        return true;
    }

    /**
     * ÕANZX擾
     *
     * @access  public
     * @return  array
     */
    function getLastAccessLog($logfile)
    {
        if (!$lines = DataPhp::fileDataPhp($logfile)) {
            return false;
        }
        if (!isset($lines[1])) {
            return false;
        }
        $line = rtrim($lines[1]);
        $lar = explode("\t", $line);
        
        $alog['user']   = $lar[6];
        $alog['date']   = $lar[0];
        $alog['ip']     = $lar[1];
        $alog['host']   = $lar[2];
        $alog['ua']     = $lar[3];
        $alog['referer'] = $lar[4];
        
        return $alog;
    }
    
    
    /**
     * ANZXOɋL^
     *
     * @access  public
     * @return  boolean
     */
    function recAccessLog($logfile, $maxline = 100, $format = 'dataphp')
    {
        global $_conf, $_login;
        
        // Ot@C̒g擾
        $lines = array();
        if (file_exists($logfile)) {
            if ($format == 'dataphp') {
                $lines = DataPhp::fileDataPhp($logfile);
            } else {
                $lines = file($logfile);
            }
        }
        
        if ($lines) {
            // s
            while (sizeof($lines) > $maxline -1) {
                array_pop($lines);
            }
        } else {
            $lines = array();
        }
        $lines = array_map('rtrim', $lines);
        
        // ϐݒ
        $date = date('Y/m/d (D) G:i:s');
    
        $remoto_host = P2Util::getRemoteHost();

        $user = isset($_login->user_u) ? $_login->user_u : "";
        
        // VOsݒ
        $newdata = $date."<>".$_SERVER['REMOTE_ADDR']."<>".$remoto_host."<>".$_SERVER['HTTP_USER_AGENT']."<>".$_SERVER['HTTP_REFERER']."<>".""."<>".$user;
        //$newdata = htmlspecialchars($newdata, ENT_QUOTES);

        // ܂^uSĊO
        $newdata = str_replace("\t", "", $newdata);
        // <>^uɕϊ
        $newdata = str_replace("<>", "\t", $newdata);

        // Vf[^ԏɒǉ
        @array_unshift($lines, $newdata);
        
        $cont = implode("\n", $lines) . "\n";

        FileCtl::make_datafile($logfile, $_conf['p2_perm']);
        
        // ݏ
        if ($format == 'dataphp') {
            if (!DataPhp::writeDataPhp($logfile, $cont, $_conf['p2_perm'])) {
                return false;
            }
        } else {
            if (file_put_contents($logfile, $cont, LOCK_EX) === false) {
                trigger_error("file_put_contents(" . $logfile . ")", E_USER_WARNING);
                return false;
            }
        }
        
        return true;
    }

    /**
     * 2chOCIDPASSƎOCݒۑ
     *
     * @access  public
     * @return  boolean
     */
    function saveIdPw2ch($login2chID, $login2chPW, $autoLogin2ch = '')
    {
        global $_conf;
        
        require_once P2_LIB_DIR . '/md5_crypt.inc.php';
        
        $md5_crypt_key = P2Util::getAngoKey();
        $crypted_login2chPW = md5_encrypt($login2chPW, $md5_crypt_key, 32);
        $idpw2ch_cont = <<<EOP
<?php
\$rec_login2chID = '{$login2chID}';
\$rec_login2chPW = '{$crypted_login2chPW}';
\$rec_autoLogin2ch = '{$autoLogin2ch}';
?>
EOP;
        FileCtl::make_datafile($_conf['idpw2ch_php'], $_conf['pass_perm']);
        if (!$fp = fopen($_conf['idpw2ch_php'], 'wb')) {
            die("p2 Error: {$_conf['idpw2ch_php']} XVł܂ł");
            return false;
        }
        @flock($fp, LOCK_EX);
        fputs($fp, $idpw2ch_cont);
        @flock($fp, LOCK_UN);
        fclose($fp);
        
        return true;
    }

    /**
     * 2chOC̕ۑςIDPASSƎOCݒǂݍ
     *
     * @access  public
     * @return  array|false
     */
    function readIdPw2ch()
    {
        global $_conf;
        
        require_once P2_LIB_DIR . '/md5_crypt.inc.php';
        
        if (!file_exists($_conf['idpw2ch_php'])) {
            return false;
        }
        
        $rec_login2chID = NULL;
        $login2chPW = NULL;
        $rec_autoLogin2ch = NULL;
        
        include $_conf['idpw2ch_php'];

        // pX𕡍
        if (!is_null($rec_login2chPW)) {
            $md5_crypt_key = P2Util::getAngoKey();
            $login2chPW = md5_decrypt($rec_login2chPW, $md5_crypt_key, 32);
        }
        
        return array($rec_login2chID, $login2chPW, $rec_autoLogin2ch);
    }
    
    /**
     * @access  public
     * @return  string
     */
    function getAngoKey()
    {
        global $_login;
        
        return $_login->user . $_SERVER['SERVER_NAME'] . $_SERVER['SERVER_SOFTWARE'];
    }
    
    /**
     * @access  public
     * @return  string
     */
    function getCsrfId()
    {
        global $_login;
        
        return md5($_login->user . $_login->pass_x . $_SERVER['HTTP_USER_AGENT']);
    }
    
    /**
     * 403 FobbidenHTMLo͂
     * 2007/01/20 EZwebł́A403y[WŖ{\Ȃ̂mFB
     *
     * @access  public
     * @return  void
     */
    function print403($msg = '', $die = true)
    {
        header('HTTP/1.0 403 Forbidden');
        echo <<<ERR
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
    <title>403 Forbidden</title>
</head>
<body>
    <h1>403 Forbidden</h1>
    <p>{$msg}</p>
</body>
</html>
ERR;
        // IEftHg̃bZ[W\Ȃ悤ɃXy[Xo
        if (strstr($_SERVER['HTTP_USER_AGENT'], 'MSIE')) {
            for ($i = 0 ; $i < 512; $i++) {
                echo ' ';
            }
        }
        
        $die and die;
    }
    
    // {{{ session_gc()

    /**
     * ZbVt@C̃K[xbWRNV
     *
     * session.save_path̃pX̐[2傫ꍇAK[xbWRNV͍sȂ
     * ŃK[xbWRNVȂƂȂB
     *
     * @access  public
     * @return  void
     *
     * @link http://jp.php.net/manual/ja/ref.session.php#ini.session.save-path
     */
    function session_gc()
    {
        global $_conf;

        if (session_module_name() != 'files') {
            return;
        }

        $d = (int)ini_get('session.gc_divisor');
        $p = (int)ini_get('session.gc_probability');
        mt_srand();
        if (mt_rand(1, $d) <= $p) {
            $m = (int)ini_get('session.gc_maxlifetime');
            FileCtl::garbageCollection($_conf['session_dir'], $m);
        }
    }

    // }}}

    /**
     * Weby[W擾
     *
     * Ƃ݂ȂR[h
     * 200 OK
     * 206 Partial Content
     *
     * XVȂnullԂ
     * 304 Not Modified
     *
     * @static
     * @access  public
     * @param   string  $url     URL
     * @param   integer $code    X|XR[h
     * @param   integer $timeout ڑ^CAEgԕb
     * @param   array   $headers ǉwb_itB[hL[ => tB[hlj
     * @return  string|null|false     y[We|304|s
     */
    function getWebPage($url, &$code, &$error_msg, $timeout = 15, $headers = array())
    {
        //  &$code = null ͋o[WPHPł͕s
        
        require_once "HTTP/Request.php";
    
        $params = array("timeout" => $timeout);
        
        if (!empty($GLOBALS['_conf']['proxy_use'])) {
            $params['proxy_host'] = $GLOBALS['_conf']['proxy_host'];
            $params['proxy_port'] = $GLOBALS['_conf']['proxy_port'];
        }
        
        $req =& new HTTP_Request($url, $params);
        
        // If-Modified-Since => gmdate('D, d M Y H:i:s', time()) . ' GMT';
        
        if ($headers) {
            foreach ($headers as $k => $v) {
                $req->addHeader($k, $v);
            }
        }

        $response = $req->sendRequest();

        if (PEAR::isError($response)) {
            $error_msg = $response->getMessage();
        } else {
            $code = $req->getResponseCode();
            // Ƃ݂ȂR[h
            if ($code == 200 || $code == 206) {
                return $req->getResponseBody();
            // XVȂnullԂ
            } elseif ($code == 304) {
                // 304̎́A$req->getResponseBody() ͋󕶎""ƂȂ
                return null;
            } else {
                //var_dump($req->getResponseHeader());
                $error_msg = $code;
            }
        }
    
        return false;
    }

    /**
     * gт̌ŗL[IDABBMɋKĂ邩ǂ₢킹
     *
     * http://qb5.2ch.net/test/read.cgi/operate/1093340433/99
     * http://qb5.2ch.net/test/read.cgi/operate/1093340433/241
     * my $AHOST = "$NOWTIME.$$.c.$FORM{'bbs'}.$FORM{'key'}.A.B.C.D.E.$idnotane.bbm.2ch.net"; 
     *
     * @static
     * @access  public
     * @return  boolean
     */
    function isKIDBurnedByBBM($sn, $bbs = null, $key = null)
    {
        if (!$sn) {
            return false;
        }
        
        $kid = P2Util::kidForBBM($sn);
    
        //$bbm_host = 'niku.2ch.net';
        
        !$bbs and $bbs = 'd';
        !$key and $key = 'e';
        
        $query_host = time() . ".b.c.{$bbs}.{$key}.A.B.C.D.E." . $kid . '.bbm.2ch.net';
    
        // ₢킹s
        $result_addr = gethostbyname($query_host);
        /* var_dump($query_addr, $result_addr); */
        if ($result_addr == '127.0.0.2') {
            return TRUE; // BBMɏĂĂ
        }
        return FALSE; // BBMɏĂĂȂ
    }
    
    /**
     * gт̌ŗL[IDBBMpɐK
     *
     * http://qb5.2ch.net/test/read.cgi/operate/1093340433/99
     * http://qb5.2ch.net/test/read.cgi/operate/1093340433/241
     *
     * @static
     * @access  private
     * @return  string
     */
    function kidForBBM($kid)
    {
        // A_[XRÁAnCtɕϊ
        // http://qb5.2ch.net/test/read.cgi/operate/1093340433/84
        $kid = str_replace('_', '-', $kid);
        $kid = preg_replace('/\.ezweb\.ne\.jp$/' , '', $kid);

        return $kid;
    }

    /**
     * ݂URL擾iGETNG[͂Ȃj
     *
     * @see  http://ns1.php.gr.jp/pipermail/php-users/2003-June/016472.html
     *
     * @static
     * @access  public
     * @return  string
     */
    function getMyUrl()
    {
        $s = empty($_SERVER['HTTPS']) ? '' : 's';
        // |[gԍw肵́A$_SERVER['HTTP_HOST'] Ƀ|[gԍ܂Ŋ܂܂悤
        $url = "http{$s}://" . $_SERVER['HTTP_HOST'] . $_SERVER['SCRIPT_NAME'];
        
        return $url;
    }
    
    /**
     * VvHTML\
     * iPɃeLXg𑗂auȂǂ́A\ĂȂj
     *
     * @static
     * @access  public
     * @return  void
     */
    function printSimpleHtml($body)
    {
        echo "<html><body>{$body}</body></html>";
    }
    
    /**
     * t@Cw肵āAVACYꂽzf[^}[WXVĩf[^ɏ㏑}[Wj
     *
     * @static
     * @access  public
     * @param   array    $data
     * @param   string   $file
     * @return  boolean
     */
    function updateArraySrdFile($data, $file)
    {
        // ̃f[^}[W擾
        if (file_exists($file)) {
            if ($cont = file_get_contents($file)) {
                $array = unserialize($cont);
                if (is_array($array)) {
                    $data = array_merge($array, $data);
                }
            }
        }
        
        // }[WXVȂ̂ŏ㏑f[^ۂ͉̎Ȃ
        if (empty($data) || !is_array($data)) {
            return false;
        }

        if (file_put_contents($file, serialize($data), LOCK_EX) === false) {
            trigger_error("file_put_contents(" . $file . ")", E_USER_WARNING);
            return false;
        }
        return true;
    }
    
    /**
     * HTML^O <a href="$url">$html</a> 𐶐
     *
     * @static
     * @access  public
     * @param   string  $url   蓮 htmlspecialchars() 邱ƁB
     *                         http_build_query() 𗘗p鎞lāi&amp;jA htmlspecialchars() ͂ĂȂB
     * @param   string  $html  NHTMLB蓮 htmlspecialchars() 邱ƁB
     * @param   array   $attr  ǉB htmlspecialchars() ikeyÔ߁j
     * @return  string
     */
    function tagA($url, $html = '', $attr = array())
    {
        $attr_html = '';
        if (is_array($attr)) {
            foreach ($attr as $k => $v) {
                $attr_html .= ' ' . htmlspecialchars($k) . '="' . htmlspecialchars($v) . '"';
            }
        }
        $html = (strlen($html) == 0) ? $url : $html;
        
        return '<a href="' . $url . "\"{$attr_html}>" . $html . '</a>';
    }

    /**
     * 2006/11/24 $_info_msg_ht 𒼐ڈ̂͂߂Ẵ\bhʂ
     *
     * @static
     * @access  public
     * @return  void
     */
    function pushInfoHtml($html)
    {
        global $_info_msg_ht;
        
        if (!isset($_info_msg_ht)) {
            $_info_msg_ht = $html;
        } else {
            $_info_msg_ht .= $html;
        }
    }

    // p~\
    function pushInfoMsgHtml($html)
    {
        P2Util::pushInfoHtml($html);
    }
    
    /**
     * @static
     * @access  public
     * @return  void
     */
    function printInfoHtml()
    {
        global $_info_msg_ht, $_conf;
        
        if (!isset($_info_msg_ht)) {
            return;
        }
        
        if ($_conf['ktai'] && $_conf['k_save_packet']) {
            echo mb_convert_kana($_info_msg_ht, 'rnsk');
        } else {
            echo $_info_msg_ht;
        }
        
        $_info_msg_ht = '';
    }

    // p~\
    function printInfoMsgHtml()
    {
        P2Util::printInfoHtml();
    }
    
    /**
     * @static
     * @access  public
     * @return  string|null
     */
    function getInfoHtml()
    {
        global $_info_msg_ht;
        
        if (!isset($_info_msg_ht)) {
            return null;
        }
        
        $info_msg_ht = $_info_msg_ht;
        $_info_msg_ht = '';
        
        return $info_msg_ht;
    }

    /**
     * O̕ϐiGET, POST, COOKIEj擾
     *
     * @static
     * @access  public
     * @param   string|array  $key      擾Ώۂ̃L[
     * @param   mixed         $alt      l !isset() ̏ꍇ̑֒l
     * @param   array|string  $methods  擾Ώۃ\bhizȂODj
     * @return  string|array  L[zŎw肳Ă΁AzŕԂ
     */
    function getReq($key, $alt = null, $methods = array('GET', 'POST'))
    {
        if (is_array($key)) {
            $req = array_flip($key);
            foreach ($req as $k => $v) {
                $req[$k] = $alt;
            }
        } else {
            $req = $alt;
        }
        
        if (!is_array($methods)) {
            $methods = array($methods);
        } else {
            $methods = array_reverse($methods);
        }
        
        foreach ($methods as $method) {
            $globalsName = '_' . $method;
            if (is_array($key)) {
                foreach ($key as $v) {
                    isset($GLOBALS[$globalsName][$v]) and $req[$v] = $GLOBALS[$globalsName][$v];
                }
            } else {
                isset($GLOBALS[$globalsName][$key]) and $req = $GLOBALS[$globalsName][$key];
            }
        }
        
        return $req;
    }

    /**
     * iANZX[Új[gzXg擾
     *
     * @param   string  $empty  gethostbyaddr() IPԂ̎̑֕B
     * @return  string
     */
    function getRemoteHost($empty = '')
    {
        // gethostbyaddr() ́AsXNvgłLbVȂ悤Ȃ̂ŃLbV
        static $gethostbyaddr_;
        
        if (isset($_SERVER['REMOTE_HOST'])) {
            return $_SERVER['REMOTE_HOST'];
        }
        
        if (php_sapi_name() == 'cli') {
            return 'cli';
        }
        
        if (!isset($gethostbyaddr_)) {
            $gethostbyaddr_ = gethostbyaddr($_SERVER['REMOTE_ADDR']);
        }
        
        return ($gethostbyaddr_ == $_SERVER['REMOTE_ADDR']) ? $empty : $gethostbyaddr_;
    }
}

